/*
 * Copyright (c) 2018, Linz Center of Mechatronics GmbH (LCM), web: www.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. web: x2c.lcm.at
 * $LastChangedRevision: 4463 $
 * $LastChangedDate:: 2026-08-17 13:59:56 +0200#$
 */
/* USERCODE-BEGIN:Description */
//*     Description:                                                           *
/* USERCODE-END:Description */

package at.lcm.x2c.library.general;

import at.lcm.x2c.core.structure.*;
import at.lcm.bu21.general.dtypes.*;

/* USERCODE-BEGIN:Imports */
import at.lcm.x2c.utils.QFormat;

/* USERCODE-END:Imports */

@SuppressWarnings("unused")
public class ConvFnc_Sin2Limiter_FiP16 extends JavaConversionFunction {
    private static final long serialVersionUID = 1L;

    @Override
    public void convertMaskToImplementation() throws Exception {
        MaskDouble TrMaskVal = (MaskDouble)this.getMaskParameter("Tr").getMaskDataType();
        TNumeric TrMaskData = (TNumeric)TrMaskVal.getData();
        double mp_Tr = TrMaskData.getReal(0, 0);
        MaskDouble TfMaskVal = (MaskDouble)this.getMaskParameter("Tf").getMaskDataType();
        TNumeric TfMaskData = (TNumeric)TfMaskVal.getData();
        double mp_Tf = TfMaskData.getReal(0, 0);
        MaskDouble ts_factMaskVal = (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
        TNumeric ts_factMaskData = (TNumeric)ts_factMaskVal.getData();
        double mp_ts_fact = ts_factMaskData.getReal(0, 0);

        TNumeric RateUpCtrVal = this.getImplementationParameterData("RateUp");
        double cp_RateUp = Double.NaN;
        TNumeric RateDownCtrVal = this.getImplementationParameterData("RateDown");
        double cp_RateDown = Double.NaN;

        /* Check if sample time factor is an integer value */
        if (Math.rint(mp_ts_fact) != mp_ts_fact) {
            throw new Exception("Sample time factor must be a whole number");
        }
        /* Check if sample time factor is within the valid range (upper limit defined by unsigned 16-bit integer range) */
        if ((mp_ts_fact < 1.0) || (mp_ts_fact > 65535.0)) {
            throw new Exception("Sample time factor must be at least 1 and at most 65535");
        }
        /* Block sample time */
        double bp_ts = mp_ts_fact * this.getDedicatedBlock().getModel().getSampleTime();
        /* Check if Block sample time has a valid value */
        if (bp_ts <= 0.0) {
            throw new Exception("Block sample time must be greater than zero");
        }

        /* ATTENTION: */
        /* The M2I conversion function may either use the mp_* or *MaskVal value to get the Mask Parameter value */
        /* For new or updated implementations, the mp_* value shall be used where possible */
        /* Currently, the mp_* value cannot be used for getting non-scalar Mask Parameter data but will return only the first element for these */
        /* The Implementation Parameter assignment variables cp_* can and shall be used for all Implementation Parameter data types */

        /* INFO: Implementation data assignment for array types when using the cp_* variables */
        /* If the cp_* parameter is a FLASH ARRAY, the cp_* variable is assigned an array type but without an actual array */
        /* The M2I conversion function has to assign an array with the correct size and fill it with content */
        /* If the cp_* parameter is a RAM ARRAY, the cp_* variable is assigned an array with the correct size */
        /* The first element is assigned an invalid value while the other elements are (auto)initialized with zero */
        /* The M2I conversion function has to fill the array with content */

        /* Mask parameter values */
        /* mp_Tr OR TrMaskVal (Number) */
        /* mp_Tf OR TfMaskVal (Number) */
        /* mp_ts_fact OR ts_factMaskVal (Number) */

        /* USERCODE-BEGIN:ConvMaskToImplementation */
		double Tr, Tf;
		double Ts = 0;
		int ts_fact;
		final int BITS = 32; /* internal usage of 32 bit variables for higher resolution */

		// get parameter values
		Tr = Double.valueOf(TrMaskVal.getValue());
		Tf = Double.valueOf(TfMaskVal.getValue());
		ts_fact = Double.valueOf(ts_factMaskVal.getValue()).intValue();

		// validate controller parameters
		if (ts_fact <= 0) {
			ts_fact = 1;
		}

		// calculate sample time
		Ts = ts_fact * this.getDedicatedBlock().getModel().getSampleTime();

		// check range of rising/falling time
		if (Tr < Ts) {
			Tr = Ts;
		}
		if (Tf < Ts) {
			Tf = Ts;
		}

		// calculate Q-values
		RateUpCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(Ts / Tr, BITS - 1, BITS, true)));
		RateDownCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(Ts / Tf, BITS - 1, BITS, true)));

        /* USERCODE-END:ConvMaskToImplementation */

        /* Implementation Parameter values */
        /* cp_RateUp OR RateUpCtrVal (Value) */
        /* cp_RateDown OR RateDownCtrVal (Value) */

        if (Double.isNaN(cp_RateUp)) {
            this.setImplementationParameterData("RateUp", RateUpCtrVal);
        } else {
            this.setImplementationParameterData("RateUp", new TNumeric(cp_RateUp));
        }
        if (Double.isNaN(cp_RateDown)) {
            this.setImplementationParameterData("RateDown", RateDownCtrVal);
        } else {
            this.setImplementationParameterData("RateDown", new TNumeric(cp_RateDown));
        }
    }

    @Override
    public void convertImplementationToMask() throws Exception {
        MaskDouble TrMaskVal = (MaskDouble)this.getMaskParameter("Tr").getMaskDataType();
        TNumeric TrMaskData = (TNumeric)TrMaskVal.getData();
        double mp_Tr = Double.NaN;
        MaskDouble TfMaskVal = (MaskDouble)this.getMaskParameter("Tf").getMaskDataType();
        TNumeric TfMaskData = (TNumeric)TfMaskVal.getData();
        double mp_Tf = Double.NaN;
        MaskDouble ts_factMaskVal = (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
        TNumeric ts_factMaskData = (TNumeric)ts_factMaskVal.getData();
        double mp_ts_fact = ts_factMaskData.getReal(0, 0);

        TNumeric RateUpCtrVal = this.getImplementationParameterData("RateUp");
        double cp_RateUp = RateUpCtrVal.getReal(0, 0);
        TNumeric RateDownCtrVal = this.getImplementationParameterData("RateDown");
        double cp_RateDown = RateDownCtrVal.getReal(0, 0);

        /* Check if sample time factor is an integer value */
        if (Math.rint(mp_ts_fact) != mp_ts_fact) {
            throw new Exception("Sample time factor must be a whole number");
        }
        /* Check if sample time factor is within the valid range (upper limit defined by unsigned 16-bit integer range) */
        if ((mp_ts_fact < 1.0) || (mp_ts_fact > 65535.0)) {
            throw new Exception("Sample time factor must be at least 1 and at most 65535");
        }
        /* Block sample time */
        double bp_ts = mp_ts_fact * this.getDedicatedBlock().getModel().getSampleTime();
        /* Check if Block sample time has a valid value */
        if (bp_ts <= 0.0) {
            throw new Exception("Block sample time must be greater than zero");
        }

        /* ATTENTION: */
        /* The I2M conversion function may either use the cp_* or *CtrlVal value to get the Implementation Parameter value */
        /* For new or updated implementations, the cp_* value shall be used for all Implementation Parameter data types */
        /* The Mask Parameter assignment variables cp_* shall be used where possible */
        /* Currently, the mp_* variable assignment value cannot be used for setting non-scalar Mask Parameter data */

        /* Implementation Parameter values */
        /* cp_RateUp OR RateUpCtrVal (Value) */
        /* cp_RateDown OR RateDownCtrVal (Value) */

        /* USERCODE-BEGIN:ConvImplementationToMask */
		double Ts = 0;
		int ts_fact;
		double RateUp, RateDown;
		final int BITS = 32; /* internal usage of 32 bit variables for higher resolution */

		// get controller parameter
		RateUp = RateUpCtrVal.getReal(0, 0);
		RateDown = RateDownCtrVal.getReal(0, 0);

		// get sample time information from model (sample time information can't be obtained from target)
		ts_fact = Double.valueOf(ts_factMaskVal.getValue()).intValue();
		Ts = ts_fact * this.getDedicatedBlock().getModel().getSampleTime();

		// set mask parameter
		TrMaskData.setReal(0, 0, QFormat.getDecValue((long) (Ts / RateUp), BITS - 1, BITS, true));
		TfMaskData.setReal(0, 0, QFormat.getDecValue((long) (Ts / RateDown), BITS - 1, BITS, true));

        /* USERCODE-END:ConvImplementationToMask */

        /* Mask parameter values */
        /* mp_Tr OR TrMaskVal (Number) */
        /* mp_Tf OR TfMaskVal (Number) */
        /* mp_ts_fact OR ts_factMaskVal (Number) */

        if (Double.isNaN(mp_Tr)) {
            this.getMaskParameter("Tr").setValue(TrMaskData.toFullString());
        } else {
            this.getMaskParameter("Tr").setValue(new TNumeric(mp_Tr).toFullString());
        }
        if (Double.isNaN(mp_Tf)) {
            this.getMaskParameter("Tf").setValue(TfMaskData.toFullString());
        } else {
            this.getMaskParameter("Tf").setValue(new TNumeric(mp_Tf).toFullString());
        }
    }
}
